.eqv    EXIT2 93
.eqv	MATRIX_SIZE 10

.text
_start:
	call main
	
	li	a0, 0
	li	a7, EXIT2
	ecall
	ebreak

main:
	addi	sp, sp, -20
	sw	ra, 0(sp)
	sw	s0, 4(sp)
	sw	s1, 8(sp)
	sw	s2, 12(sp)
	sw	s4, 16(sp)
	
	li	s0, MATRIX_SIZE
	la	s1, A
	la	s2, B
	la	s3, res
	
	li	a0, 0 # i = 0
	
for_i:
	beq	a0, s0, end_for_i
	li	a1, 0 # j = 0

for_j:
	beq	a1, s0, end_for_j
	li	a2, 0 # k = 0
	
for_k: #not the syscall :p
	beq	a2, s0, end_for_k
	
	#  -- compute section --
	
	mul	t0, a0, s0 # i * MAXTRIX_SIZE
	mul	t1, a2, s0 # k * MATRIX_SIZE
	
	#get res[i][j] value on t3
	li	t2, 0 #useless
	add	t2, t0, a1
	slli	t2, t2, 2
	add	t2, t2, s3 #@ of res[i][j]
	lw	t3, 0(t2)
	
	#get A[i][k] value on t4
	li	t4, 0 #useless
	add	t4, t0, a2
	slli	t4, t4, 2
	add	t4, t4, s1
	lw	t4, 0(t4)
	
	#get B[k][j] value on t5
	li	t5, 0
	add	t5, t1, a1
	slli	t5, t5, 2
	add	t5, t5, s2
	lw	t5, 0(t5)
	
	mul	t4, t4, t5 #A[i][k] * B[k][j]
	add	t3, t3, t4 #res[i][j] += (A[i][k] * B[k][j])
	sw	t3, 0(t2)
	
	#  -- end compute section --
	
	addi	a2, a2, 1 # k++
	j	for_k
	
end_for_k:
	addi	a1, a1, 1 # j++
	j 	for_j
	
end_for_j:
	addi	a0, a0, 1 # i++
	j 	for_i
	
end_for_i:
	lw	s4, 16(sp)
	lw	s3, 12(sp)
	lw	s2, 8(sp)
	lw	s1, 4(sp)
	lw	ra, 0(sp)
	addi	sp, sp, 20
	ret

.data
.align 2

A:		
.word 0x1
.word 0x2
.word 0x3
.word 0x4
.word 0x5
.word 0x6
.word 0x7
.word 0x8
.word 0x9
.word 0xa
.word 0xb
.word 0xc
.word 0xd
.word 0xe
.word 0xf
.word 0x10
.word 0x11
.word 0x12
.word 0x13
.word 0x14
.word 0x15
.word 0x16
.word 0x17
.word 0x18
.word 0x19
.word 0x1a
.word 0x1b
.word 0x1c
.word 0x1d
.word 0x1e
.word 0x1f
.word 0x20
.word 0x21
.word 0x22
.word 0x23
.word 0x24
.word 0x25
.word 0x26
.word 0x27
.word 0x28
.word 0x29
.word 0x2a
.word 0x2b
.word 0x2c
.word 0x2d
.word 0x2e
.word 0x2f
.word 0x30
.word 0x31
.word 0x32
.word 0x33
.word 0x34
.word 0x35
.word 0x36
.word 0x37
.word 0x38
.word 0x39
.word 0x3a
.word 0x3b
.word 0x3c
.word 0x3d
.word 0x3e
.word 0x3f
.word 0x40
.word 0x41
.word 0x42
.word 0x43
.word 0x44
.word 0x45
.word 0x46
.word 0x47
.word 0x48
.word 0x49
.word 0x4a
.word 0x4b
.word 0x4c
.word 0x4d
.word 0x4e
.word 0x4f
.word 0x50
.word 0x51
.word 0x52
.word 0x53
.word 0x54
.word 0x55
.word 0x56
.word 0x57
.word 0x58
.word 0x59
.word 0x5a
.word 0x5b
.word 0x5c
.word 0x5d
.word 0x5e
.word 0x5f
.word 0x60
.word 0x61
.word 0x62
.word 0x63
.word 0x64

B:
.word 0x1
.word 0x2
.word 0x3
.word 0x4
.word 0x5
.word 0x6
.word 0x7
.word 0x8
.word 0x9
.word 0xa
.word 0xb
.word 0xc
.word 0xd
.word 0xe
.word 0xf
.word 0x10
.word 0x11
.word 0x12
.word 0x13
.word 0x14
.word 0x15
.word 0x16
.word 0x17
.word 0x18
.word 0x19
.word 0x1a
.word 0x1b
.word 0x1c
.word 0x1d
.word 0x1e
.word 0x1f
.word 0x20
.word 0x21
.word 0x22
.word 0x23
.word 0x24
.word 0x25
.word 0x26
.word 0x27
.word 0x28
.word 0x29
.word 0x2a
.word 0x2b
.word 0x2c
.word 0x2d
.word 0x2e
.word 0x2f
.word 0x30
.word 0x31
.word 0x32
.word 0x33
.word 0x34
.word 0x35
.word 0x36
.word 0x37
.word 0x38
.word 0x39
.word 0x3a
.word 0x3b
.word 0x3c
.word 0x3d
.word 0x3e
.word 0x3f
.word 0x40
.word 0x41
.word 0x42
.word 0x43
.word 0x44
.word 0x45
.word 0x46
.word 0x47
.word 0x48
.word 0x49
.word 0x4a
.word 0x4b
.word 0x4c
.word 0x4d
.word 0x4e
.word 0x4f
.word 0x50
.word 0x51
.word 0x52
.word 0x53
.word 0x54
.word 0x55
.word 0x56
.word 0x57
.word 0x58
.word 0x59
.word 0x5a
.word 0x5b
.word 0x5c
.word 0x5d
.word 0x5e
.word 0x5f
.word 0x60
.word 0x61
.word 0x62
.word 0x63
.word 0x64

res:	.space 400
